<?php

/*
 +-----------------------------------------------------------------------+
 | program/steps/settings/save_prefs.inc                                 |
 |                                                                       |
 | This file is part of the RoundCube Webmail client                     |
 | Copyright (C) 2005-2007, RoundCube Dev. - Switzerland                 |
 | Licensed under the GNU GPL                                            |
 |                                                                       |
 | PURPOSE:                                                              |
 |   Save user preferences to DB and to the current session              |
 |                                                                       |
 +-----------------------------------------------------------------------+
 | Author: Thomas Bruederli <roundcube@gmail.com>                        |
 +-----------------------------------------------------------------------+

 $Id: save_prefs.inc 1403 2008-05-19 08:09:38Z alec $

*/

/*
*******************************************
* Agregado por: Carlos Chiriboga Calderon *
*******************************************

Esta parte es la que permite el cambio de password desde el menu preferencias :)

*/

$err_pass = false;

if ($_POST['_password1'] != "")
{
        if(trim($_POST['_password1']) == trim($_POST['_password2'])){
            $_passwd    = $_POST['_password1'];
            $_user      = $_SESSION['username'];
			$bErrorDB = FALSE;

			dl('sqlite3.so');
			include_once("libs/misc.lib.php");
			include_once "configs/default.conf.php";
			include_once "libs/paloSantoDB.class.php";

			$pDB = new paloDB("sqlite3:////var/www/db/acl.db");
			if(!empty($pDB->errMsg)) {
				echo "ERROR DE DB: $pDB->errMsg <br/>";
				$bErrorDB = TRUE;
			} else {
				// SQLite no soporta UPDATE con múltiples tablas. Se tiene que averiguar
				// el valor correcto de acl_profile_properties.id_profile
				$sPeticionSQL = 
					'SELECT a.id_profile '.
					'FROM acl_resource r, acl_user_profile up, acl_profile_properties a, acl_profile_properties b '.
					'WHERE r.name = "webmail" '.
						'AND up.id_resource = r.id '.
						'AND up.id_profile = a.id_profile '.
						'AND a.id_profile = b.id_profile '.
						'AND a.property = "login" '.
						'AND b.property = "domain" '.
						'AND (a.value || "." || b.value) = ?';
				$tupla = $pDB->getFirstRowQuery($sPeticionSQL, FALSE, array($_SESSION['username']));
				if (!is_array($tupla)) {
					print "ERROR DE DB: ".$pDB->errMsg;
					$bErrorDB = TRUE;
				} elseif (count($tupla) > 0) {
					$idPerfil = $tupla[0];
					$sPeticionSQL = 'UPDATE acl_profile_properties SET value = ? WHERE id_profile = ? AND property = "password"';

					$r = $pDB->genQuery($sPeticionSQL, array($_passwd, $idPerfil));
					if (!$r) {
						print "ERROR DE DB: ".$pDB->errMsg;
						$bErrorDB = TRUE;
			        }
				}
			}
			
			if (!$bErrorDB) {
				$pDB = new paloDB("sqlite3:////var/www/db/email.db");
				if(!empty($pDB->errMsg)) {
					echo "ERROR DE DB: $pDB->errMsg <br/>";
					$bErrorDB = TRUE;
				} else {
					$sPeticionSQL = 'UPDATE accountuser SET password = ? WHERE username = ?';
					$r = $pDB->genQuery($sPeticionSQL, array($_passwd, $_SESSION['username']));
					if (!$r) {
						print "ERROR DE DB: ".$pDB->errMsg;
						$bErrorDB = TRUE;
			        }
				}
			}
			
			// Cambiar clave IMAP si no se ha encontrado error de DB
			if (!$bErrorDB) {
			    exec("echo \"$_passwd\" | sudo -u root /usr/sbin/saslpasswd2 -c $_user -u example.com",$output);
			    $_SESSION['password'] = $RCMAIL->encrypt_passwd($_POST['_password1']);
			}
        }else
            $err_pass = true;
}

//Fin del Cambio de Password

$a_user_prefs = array(
  'timezone'     => isset($_POST['_timezone']) ? floatval($_POST['_timezone']) : $CONFIG['timezone'],
  'dst_active'   => isset($_POST['_dst_active']) ? TRUE : FALSE,
  'pagesize'     => is_numeric($_POST['_pagesize']) ? max(2, intval($_POST['_pagesize'])) : $CONFIG['pagesize'],
  'prettydate'   => isset($_POST['_pretty_date']) ? TRUE : FALSE,
  'prefer_html'  => isset($_POST['_prefer_html']) ? TRUE : FALSE,
  'htmleditor'   => isset($_POST['_htmleditor']) ? TRUE : FALSE,
  'preview_pane' => isset($_POST['_preview_pane']) ? TRUE : FALSE,
  'read_when_deleted' => isset($_POST['_read_when_deleted']) ? TRUE : FALSE,
  'flag_for_deletion' => isset($_POST['_flag_for_deletion']) ? TRUE : FALSE,
  'logout_purge' => isset($_POST['_logout_purge']) ? TRUE : FALSE,
  'logout_expunge' => isset($_POST['_logout_expunge']) ? TRUE : FALSE,
  'draft_autosave' => isset($_POST['_draft_autosave']) ? intval($_POST['_draft_autosave']) : 0,
  'mdn_requests' => isset($_POST['_mdn_requests']) ? intval($_POST['_mdn_requests']) : 0,
  );

// don't override these parameters
foreach ((array)$CONFIG['dont_override'] as $p)
  $a_user_prefs[$p] = $CONFIG[$p];


// switch UI language
if (isset($_POST['_language'])) {
  $RCMAIL->load_language(get_input_value('_language', RCUBE_INPUT_POST));
}

// force min size
if ($a_user_prefs['pagesize'] < 1)
  $a_user_prefs['pagesize'] = 10;

if (isset($CONFIG['max_pagesize']) && ($a_user_prefs['pagesize'] > $CONFIG['max_pagesize']))
  $a_user_prefs['pagesize'] = (int) $CONFIG['max_pagesize'];

if($err_pass)
        $OUTPUT->show_message('passwordsnotmatch', 'error');
else{
        if ($USER->save_prefs($a_user_prefs))
          $OUTPUT->show_message('successfullysaved', 'confirmation');
}

// go to next step
rcmail_overwrite_action('preferences');

?>
